Index: trunk/MagicSoft/Mars/msignal/MExtractTimeAndChargeDigitalFilter.cc
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractTimeAndChargeDigitalFilter.cc	(revision 8144)
+++ trunk/MagicSoft/Mars/msignal/MExtractTimeAndChargeDigitalFilter.cc	(revision 8154)
@@ -1,3 +1,5 @@
 /* ======================================================================== *\
+! $Name: not supported by cvs2svn $:$Id: MExtractTimeAndChargeDigitalFilter.cc,v 1.73 2006-10-24 08:24:52 tbretz Exp $
+! --------------------------------------------------------------------------
 !
 ! *
@@ -72,4 +74,5 @@
 #include "MCalibrationPattern.h"
 #include "MExtractedSignalCam.h"
+#include "MExtralgoDigitalFilter.h"
 
 #include "MPedestalPix.h"
@@ -83,6 +86,6 @@
 const Byte_t MExtractTimeAndChargeDigitalFilter::fgLoGainFirst             =  1;
 const Byte_t MExtractTimeAndChargeDigitalFilter::fgLoGainLast              = 14;
-const Int_t  MExtractTimeAndChargeDigitalFilter::fgWindowSizeHiGain        =  4;
-const Int_t  MExtractTimeAndChargeDigitalFilter::fgWindowSizeLoGain        =  6;
+//const Int_t  MExtractTimeAndChargeDigitalFilter::fgWindowSizeHiGain        =  4;
+//const Int_t  MExtractTimeAndChargeDigitalFilter::fgWindowSizeLoGain        =  6;
 const Int_t  MExtractTimeAndChargeDigitalFilter::fgBinningResolutionHiGain = 10;
 const Int_t  MExtractTimeAndChargeDigitalFilter::fgBinningResolutionLoGain = 10;
@@ -90,5 +93,5 @@
 const Int_t  MExtractTimeAndChargeDigitalFilter::fgSignalStartBinLoGain    =  4;
 const Float_t MExtractTimeAndChargeDigitalFilter::fgOffsetLoGain           =  0.95;
-const Float_t MExtractTimeAndChargeDigitalFilter::fgLoGainStartShift       = -1.8;
+//const Float_t MExtractTimeAndChargeDigitalFilter::fgLoGainStartShift       = -1.8;
 
 // --------------------------------------------------------------------------
@@ -104,5 +107,7 @@
 //
 MExtractTimeAndChargeDigitalFilter::MExtractTimeAndChargeDigitalFilter(const char *name, const char *title) 
-    : fTimeShiftHiGain(0.), fTimeShiftLoGain(0.), fAutomaticWeights(kTRUE), fRandomIter(0)
+    : fBinningResolutionHiGain(fgBinningResolutionHiGain),
+    fBinningResolutionLoGain(fgBinningResolutionLoGain),
+    fAutomaticWeights(kTRUE), fRandomIter(0)
 {
     fName  = name  ? name  : "MExtractTimeAndChargeDigitalFilter";
@@ -110,10 +115,10 @@
 
     SetRange(fgHiGainFirst, fgHiGainLast, fgLoGainFirst, fgLoGainLast);
-    SetWindowSize();
-    SetBinningResolution();
-    SetSignalStartBin();
+    SetWindowSize(3, 5);
+//    SetBinningResolution();
+//    SetSignalStartBin();
 
     SetOffsetLoGain(fgOffsetLoGain);          // Order between both
-    SetLoGainStartShift(fgLoGainStartShift);  // is important
+//    SetLoGainStartShift(fgLoGainStartShift);  // is important
 }
 
@@ -121,20 +126,16 @@
 //
 // Checks:
-// - if a window is bigger than the one defined by the ranges, set it to the available range
+// - if a window is bigger than the one defined by the ranges, set it
+// to the available range
 // 
 // Sets:
 // - fNumHiGainSamples to: (Float_t)fWindowSizeHiGain
 // - fNumLoGainSamples to: (Float_t)fWindowSizeLoGain
-//  
+//
+// This function might be used to turn the digital filter into a
+// sliding window extractor by setting the filename to NULL
+//
 void MExtractTimeAndChargeDigitalFilter::SetWindowSize(Int_t windowh, Int_t windowl)
 {
-
-  if (windowh != fgWindowSizeHiGain)
-    *fLog << warn << GetDescriptor() 
-          << ": ATTENTION!!! If you are not Hendrik Bartko, do NOT use a different window size than the default." << endl;
-  if (windowl != fgWindowSizeLoGain)
-    *fLog << warn << GetDescriptor() 
-          << ": ATTENTION!!! If you are not Hendrik Bartko, do NOT use a different window size than the default" << endl;
-
   fWindowSizeHiGain = windowh;
   fWindowSizeLoGain = windowl;
@@ -184,6 +185,6 @@
   // size of 6. The exact numbers have to be found still.
   //
-  fNumHiGainSamples = fAmpWeightsHiGain.GetSum()/fBinningResolutionHiGain;
-  fNumLoGainSamples = fAmpWeightsLoGain.GetSum()/fBinningResolutionLoGain;
+  fNumHiGainSamples  = fWindowSizeHiGain;
+  fNumLoGainSamples  = fWindowSizeLoGain;
   fSqrtHiGainSamples = TMath::Sqrt(fNumHiGainSamples);
   fSqrtLoGainSamples = TMath::Sqrt(fNumLoGainSamples);
@@ -191,4 +192,5 @@
 }
 
+
 // --------------------------------------------------------------------------
 //
@@ -213,6 +215,4 @@
 //
 // If new weights are set
-//  fTimeShiftHiGain
-//  fTimeShiftLoGain
 //  fNumHiGainSamples
 //  fNumLoGainSamples
@@ -234,18 +234,10 @@
 
     //
-    // shift the times back to the right reference (start counting from 0)
+    // We need here the effective number of samples. In pricipal the number
+    // is different depending on the weights used and must be set
+    // event by event.
     //
-    // The high-gain has the extraction offset (fHiGainFirst) already included
-    // here for speed reason. The low-gain has a changing extraction offset,
-    // so it will be added at every event (in FindTimeAndChargeLoGain)
-    fTimeShiftHiGain = 0.5 + 1./fBinningResolutionHiGain;
-    fTimeShiftLoGain = 0.5 + 1./fBinningResolutionLoGain;
-
-    //
-    // We need here the effective number of samples which is about 2.5 in the case of a window
-    // size of 6. The exact numbers have to be found still.
-    //
-    fNumHiGainSamples = (Float_t)fWindowSizeHiGain/2.4;
-    fNumLoGainSamples = (Float_t)fWindowSizeLoGain/2.4;
+    fNumHiGainSamples  = fAmpWeightsHiGain.GetSum()/fBinningResolutionHiGain;
+    fNumLoGainSamples  = fAmpWeightsLoGain.GetSum()/fBinningResolutionLoGain;
     fSqrtHiGainSamples = TMath::Sqrt(fNumHiGainSamples);
     fSqrtLoGainSamples = TMath::Sqrt(fNumLoGainSamples);
@@ -253,5 +245,5 @@
     // From MExtractTimeAndCharge::ReInit
     if (fSignals)
-        fSignals->SetUsedFADCSlices(fHiGainFirst, fHiGainLast+fHiLoLast, fNumHiGainSamples,
+        fSignals->SetUsedFADCSlices(fHiGainFirst, fHiGainLast/*+fHiLoLast*/, fNumHiGainSamples,
                                     fLoGainFirst, fLoGainLast, fNumLoGainSamples);
     return kTRUE;
@@ -269,9 +261,11 @@
         return kFALSE;
 
-    const Int_t rangehi = (Int_t)(fHiGainLast - fHiGainFirst + 1 + fHiLoLast);
-    const Int_t rangelo = (Int_t)(fLoGainLast - fLoGainFirst + 1);
-
-    fHiGainSignal.Set(rangehi);
-    fLoGainSignal.Set(rangelo);
+    //const Int_t rangehi = (Int_t)(fHiGainLast - fHiGainFirst + 1 + fHiLoLast);
+    //const Int_t rangelo = (Int_t)(fLoGainLast - fLoGainFirst + 1);
+
+    //cout << "ARRAYS INITIALIZED TO : " << rangehi << " " << rangelo << endl;
+
+    //fHiGainSignal.Set(rangehi);
+    //fLoGainSignal.Set(rangelo);
 
     return GetWeights();
@@ -295,220 +289,137 @@
 }
 
-void MExtractTimeAndChargeDigitalFilter::CalcBinningResArrays()
-{
-
-  fArrBinningResHiGain.Set(fWindowSizeHiGain);
-  fArrBinningResHalfHiGain.Set(fWindowSizeHiGain);
-
-  for (int i=0; i<fWindowSizeHiGain; i++)
-    {
-      fArrBinningResHiGain[i] = fBinningResolutionHiGain*i;
-      fArrBinningResHalfHiGain[i] = fArrBinningResHiGain[i] + fBinningResolutionHalfHiGain;
-    }
-
-  fArrBinningResLoGain.Set(fWindowSizeLoGain);
-  fArrBinningResHalfLoGain.Set(fWindowSizeLoGain);
-  
-  for (int i=0; i<fWindowSizeLoGain; i++)
-    {
-      fArrBinningResLoGain[i] = fBinningResolutionLoGain*i;
-      fArrBinningResHalfLoGain[i] = fArrBinningResLoGain[i] + fBinningResolutionHalfLoGain;
-    }
-}
-
 // --------------------------------------------------------------------------
 //
 // Apply the digital filter algorithm to the high-gain slices.
 //
-void MExtractTimeAndChargeDigitalFilter::FindTimeAndChargeHiGain(Byte_t *ptr, Byte_t *logain, Float_t &sum, Float_t &dsum, 
+void MExtractTimeAndChargeDigitalFilter::FindTimeAndChargeHiGain2(const Float_t *ptr, Int_t num,
+                                                                  Float_t &sum, Float_t &dsum,
+                                                                  Float_t &time, Float_t &dtime,
+                                                                  Byte_t sat, Int_t maxpos)
+{
+    // Do some handling if maxpos is last slice!
+
+    MExtralgoDigitalFilter df(fBinningResolutionHiGain, fWindowSizeHiGain,
+                              fAmpWeightsHiGain.GetArray(),
+                              fTimeWeightsHiGain.GetArray(),
+                              fPulseHiGain.GetArray());
+    df.SetData(num, ptr);
+
+    if (IsNoiseCalculation())
+    {
+        if (fRandomIter == fBinningResolutionHiGain)
+            fRandomIter = 0;
+
+        sum = df.ExtractNoise(fRandomIter);
+        fRandomIter++;
+        return;
+    }
+
+    df.Extract(/*maxpos*/);
+    df.GetSignal(sum, dsum);
+    df.GetTime(time, dtime);
+}
+
+void MExtractTimeAndChargeDigitalFilter::FindTimeAndChargeLoGain2(const Float_t *ptr, Int_t num,
+                                                                  Float_t &sum, Float_t &dsum,
+                                                                  Float_t &time, Float_t &dtime,
+                                                                  Byte_t sat, Int_t maxpos)
+{
+    MExtralgoDigitalFilter df(fBinningResolutionLoGain, fWindowSizeLoGain,
+                              fAmpWeightsLoGain.GetArray(),
+                              fTimeWeightsLoGain.GetArray(),
+                              fPulseLoGain.GetArray());
+
+    df.SetData(num, ptr);
+
+    if (IsNoiseCalculation())
+    {
+        if (fRandomIter == fBinningResolutionLoGain)
+            fRandomIter = 0;
+
+        sum = df.ExtractNoise(fRandomIter);
+        return;
+    }
+
+    df.Extract(/*maxpos*/);
+    df.GetSignal(sum, dsum);
+    df.GetTime(time, dtime);
+}
+
+/*
+// --------------------------------------------------------------------------
+//
+// Apply the digital filter algorithm to the high-gain slices.
+//
+void MExtractTimeAndChargeDigitalFilter::FindTimeAndChargeHiGain(Byte_t *first, Byte_t *logain, Float_t &sum, Float_t &dsum,
                                                                  Float_t &time, Float_t &dtime,
                                                                  Byte_t &sat, const MPedestalPix &ped, const Bool_t abflag)
 {
-
-  Int_t range = fHiGainLast - fHiGainFirst + 1;
-  
-  const Byte_t *end = ptr + range;
-  Byte_t *p     = ptr;
-
-  //
-  // Preparations for the pedestal subtraction (with AB-noise correction)
-  //
-  const Float_t pedes  = ped.GetPedestal();
-  const Float_t ABoffs = ped.GetPedestalABoffset();
-
-  const Float_t pedmean[2] = { pedes + ABoffs, pedes - ABoffs };
-
-  range += fHiLoLast;
-  fMaxBinContent = 0;
-  //
-  // Check for saturation in all other slices
-  //
-  Int_t ids = fHiGainFirst;
-  Float_t *sample = fHiGainSignal.GetArray();
-  while (p<end)
-    {
-      *sample++ = (Float_t)*p - pedmean[(ids++ + abflag) & 0x1];
-
-      if (*p > fMaxBinContent)
-	{
-          Byte_t maxpos = p-ptr;
-
-          // range-fWindowSizeHiGain+1 == fHiLoLast isn't it?
-	  if (maxpos > 1 && maxpos < (range - fWindowSizeHiGain + 1))
-	    fMaxBinContent = *p;
-	}
-
-      if (*p++ >= fSaturationLimit)
-        if (!sat)
-          sat = ids-fHiGainFirst;
-    }
-
-  //
-  // Slide with a window of size fWindowSizeHiGain over the sample 
-  // and multiply the entries with the corresponding weights
-  //
-  if (IsNoiseCalculation())
-    {
-      if (fRandomIter == fBinningResolutionHiGain)
-        fRandomIter = 0;
-      for (Int_t ids=0; ids < fWindowSizeHiGain; ids++)
+    Int_t range = fHiGainLast - fHiGainFirst + 1;
+    const Byte_t *end = first + range;
+    Byte_t       *p  = first;
+
+    const Float_t pedes  = ped.GetPedestal();
+    const Float_t ABoffs = ped.GetPedestalABoffset();
+
+    const Float_t pedmean[2] = { pedes + ABoffs, pedes - ABoffs };
+
+    Byte_t maxcont = 0;
+    Int_t  maxpos  = 0;  // obsolete for Digital Filter (used in spline!)
+    sat = 0;
+
+    //
+    // Check for saturation in all other slices
+    //
+    Int_t ids = fHiGainFirst;
+    Float_t *sample = fHiGainSignal.GetArray();
+
+    while (p<end)
+    {
+        *sample++ = (Float_t)*p - pedmean[(ids++ + abflag) & 0x1];
+
+        if (*p > maxcont)
         {
-          const Int_t   idx = fArrBinningResHiGain[ids] + fRandomIter;
-          sum              += fAmpWeightsHiGain [idx]*fHiGainSignal[ids]; 
+            maxpos = ids-fHiGainFirst-1;
+            // range-fWindowSizeHiGain+1 == fHiLoLast isn't it?
+            //if (maxpos > 1 && maxpos < (range - fWindowSizeHiGain + 1))
+            if (maxpos > 1 && maxpos < (range-1*//* - fWindowSizeHiGain + 1*//*))
+                maxcont = *p;
         }
-      fRandomIter++;
-      return;
-    }
-  
-  if (fHiLoLast != 0)
-    {
-
-      end = logain + fHiLoLast;
-
-      while (logain<end)
+
+        if (*p++ >= fSaturationLimit)
+            if (!sat)
+                sat = ids-fHiGainFirst;
+    }
+
+    if (fHiLoLast != 0)
+    {
+        end = logain + fHiLoLast;
+
+        while (logain<end)
         {
-
-          *sample++ = (Float_t)*logain - pedmean[(ids++ + abflag) & 0x1];
-
-          if (*logain++ >= fSaturationLimit)
-            if (!sat)
-              sat = ids-fHiGainFirst;
+            *sample++ = (Float_t)*logain - pedmean[(ids++ + abflag) & 0x1];
+
+            if (*logain > maxcont)
+            {
+                maxpos = ids-fHiGainFirst-1;
+
+                // FIXME!!! MUST BE THERE!
+                // range-fWindowSizeHiGain+1 == fHiLoLast isn't it?
+                //if (maxpos > 1 && maxpos < (range - fWindowSizeHiGain + 1))
+                //    maxcont = *logain;
+            }
+
+            if (*logain++ >= fSaturationLimit)
+                if (!sat)
+                    sat = ids-fHiGainFirst;
+
+            range++;
         }
     }
 
-  //
-  // allow no saturated slice 
-  //
-  //  if (sat > 0)
-  //    return;
-  
-  Float_t time_sum  = 0.;
-  Float_t fmax      = -FLT_MAX;
-  Float_t ftime_max = 0.;
-  Int_t   max_p     = -1;
-  
-  //
-  // Calculate the sum of the first fWindowSize slices
-  //
-  for (Int_t i=0;i<range-fWindowSizeHiGain+1;i++)
-    {
-      sum      = 0.;
-      time_sum = 0.;
-
-      //
-      // Slide with a window of size fWindowSizeHiGain over the sample
-      // and multiply the entries with the corresponding weights
-      //
-      for (Int_t sample=0; sample < fWindowSizeHiGain; sample++)
-      {
-        const Int_t   idx = fBinningResolutionHiGain*sample+fBinningResolutionHalfHiGain;
-        const Float_t pex = fHiGainSignal[sample+i];
-        sum              += fAmpWeightsHiGain [idx]*pex;
-        time_sum         += fTimeWeightsHiGain[idx]*pex;
-      }
-
-      if (sum>fmax)
-      {
-        fmax      = sum;
-        ftime_max = time_sum;
-        max_p     = i;
-      }
-    } /*   for (Int_t i=0;i<range-fWindowSizeHiGain+1;i++) */
-
-  if (max_p<0)
-  {
-      sum = 0;
-      time = -1;
-      dsum = -1;
-      dtime = -1;
-      return;
-  }
-
-  if (fmax==0)
-  {
-      sum = 0;
-      time = -1;
-      dsum = 0;
-      dtime = 0;
-      return;
-  }
-
-  ftime_max        /= fmax;
-  Int_t t_iter      = Int_t(ftime_max*fBinningResolutionHiGain);
-  Int_t sample_iter = 0;
-
-  while ( t_iter > fBinningResolutionHalfHiGain-1 || t_iter < -fBinningResolutionHalfHiGain )
-    {
-      if (t_iter > fBinningResolutionHalfHiGain-1)
-        {
-          t_iter -= fBinningResolutionHiGain;
-          max_p--; 
-          sample_iter--;
-        }
-      if (t_iter < -fBinningResolutionHalfHiGain)
-        {
-          t_iter += fBinningResolutionHiGain;
-          max_p++; 
-          sample_iter++;
-        }
-    }
-
-  sum = 0.;
-  time_sum = 0.;
-  if (max_p < 0)
-    max_p = 0;
-  if (max_p+fWindowSizeHiGain > range)
-    max_p = range-fWindowSizeHiGain;
-  //
-  // Slide with a window of size fWindowSizeHiGain over the sample 
-  // and multiply the entries with the corresponding weights
-  //
-  for (Int_t sample=0; sample < fWindowSizeHiGain; sample++)
-  {
-    const Int_t   idx = fArrBinningResHalfHiGain[sample] + t_iter;
-    const Int_t   ids = max_p + sample;
-    const Float_t pex = fHiGainSignal[ids];
-    sum              += fAmpWeightsHiGain [idx]*pex; 
-    time_sum         += fTimeWeightsHiGain[idx]*pex;
-  }
-
-  if (sum == 0)
-  {
-      time = -1;
-      dsum = 0;
-      dtime = 0;
-      return;
-  }
-
-  // here, the first high-gain slice is already included in the fTimeShiftHiGain
-//  time = fTimeShiftHiGain + max_p - Float_t(t_iter)/fBinningResolutionHiGain;
-  time = max_p + fTimeShiftHiGain + (Float_t)fHiGainFirst /* this shifts the time to the start of the rising edge */
-      - ((Float_t)t_iter)/fBinningResolutionHiGain;
-
-  const Float_t timefineadjust = time_sum/sum;
-  
-  if (TMath::Abs(timefineadjust) < 4./fBinningResolutionHiGain)
-    time -= timefineadjust;
-
+    FindTimeAndChargeHiGain2(fHiGainSignal.GetArray(), range,
+                             sum, dsum, time, dtime,
+                             sat, 0);
 }
 
@@ -521,151 +432,37 @@
                                                                  Byte_t &sat, const MPedestalPix &ped, const Bool_t abflag)
 {
-
-  const Int_t range = fLoGainLast - fLoGainFirst + 1;
-
-  const Byte_t *end = ptr + range;
-  Byte_t *p     = ptr;
-  //
-  // Prepare the low-gain pedestal
-  //
-  const Float_t pedes  = ped.GetPedestal();
-  const Float_t ABoffs = ped.GetPedestalABoffset();
-	
-  const Float_t pedmean[2] = { pedes + ABoffs, pedes - ABoffs };
-
-  //
-  // Check for saturation in all other slices
-  //
-  Float_t *sample = fLoGainSignal.GetArray();
-  Int_t    ids    = fLoGainFirst;
-  while (p<end)
-    {
-      *sample++ = (Float_t)*p - pedmean[(ids++ + abflag) & 0x1];
-
-      if (*p++ >= fSaturationLimit)
-        sat++;
-    }
-
-  //
-  // Slide with a window of size fWindowSizeLoGain over the sample 
-  // and multiply the entries with the corresponding weights
-  //
-  if (IsNoiseCalculation())
-    {
-      if (fRandomIter == fBinningResolutionLoGain)
-        fRandomIter = 0;
-      for (Int_t ids=0; ids < fWindowSizeLoGain; ids++)
-        {
-          const Int_t   idx = fArrBinningResLoGain[ids] + fRandomIter;
-          sum              += fAmpWeightsLoGain [idx]*fLoGainSignal[ids]; 
-        }
-      return;
-    }
-
-  Float_t time_sum  = 0.;
-  Float_t fmax      = -FLT_MAX;
-  Float_t ftime_max = 0.;
-  Int_t   max_p     = -1;
-  
-  //
-  // Calculate the sum of the first fWindowSize slices
-  //
-  for (Int_t i=0;i<range-fWindowSizeLoGain+1;i++)
-    {
-      sum      = 0.;
-      time_sum = 0.;
-      
-      //
-      // Slide with a window of size fWindowSizeLoGain over the sample 
-      // and multiply the entries with the corresponding weights
-      //
-      for (Int_t sample=0; sample < fWindowSizeLoGain; sample++)
-      {
-        const Int_t   idx = fArrBinningResHalfLoGain[sample];
-        const Float_t pex = fLoGainSignal[sample+i];
-	sum              += fAmpWeightsLoGain [idx]*pex; 
-	time_sum         += fTimeWeightsLoGain[idx]*pex;
-      }
-
-      if (sum>fmax)
-      {
-	fmax      = sum;
-	ftime_max = time_sum;
-	max_p     = i;
-      }
-    } /*   for (Int_t i=0;i<range-fWindowSizeLoGain+1;i++) */
-
-  if (max_p<0)
-  {
-      sum = 0;
-      time = -1;
-      dsum = -1;
-      dtime = -1;
-      return;
-  }
-
-  if (fmax==0)
-  {
-      sum = 0;
-      time = -1;
-      dsum = 0;
-      dtime = 0;
-      return;
-  }
-
-  ftime_max        /= fmax;
-  Int_t t_iter      = Int_t(ftime_max*fBinningResolutionLoGain);
-  Int_t sample_iter = 0;
-
-  while ( t_iter > fBinningResolutionHalfLoGain-1 || t_iter < -fBinningResolutionHalfLoGain )
-    {
-      if (t_iter > fBinningResolutionHalfLoGain-1)
-        {
-          t_iter -= fBinningResolutionLoGain;
-          max_p--; 
-          sample_iter--;
-        }
-      if (t_iter < -fBinningResolutionHalfLoGain)
-        {
-          t_iter += fBinningResolutionLoGain;
-          max_p++; 
-          sample_iter++;
-        }
-    }
-  
-  sum = 0.;
-  time_sum = 0.;
-
-  //
-  // Slide with a window of size fWindowSizeLoGain over the sample 
-  // and multiply the entries with the corresponding weights
-  //
-  for (Int_t sample=0; sample < fWindowSizeLoGain; sample++)
-  {
-    const Int_t   idx = fArrBinningResHalfLoGain[sample] + t_iter;
-    const Int_t   ids = max_p + sample;
-    const Float_t pex = ids < 0 ? 0. : ( ids >= range ? 0. : fLoGainSignal[ids]);
-    sum              += fAmpWeightsLoGain [idx]*pex; 
-    time_sum         += fTimeWeightsLoGain[idx]*pex;
-  }
-
-  if (sum == 0)
-  {
-      time = -1;
-      dsum = 0;
-      dtime = 0;
-      return;
-  }
-
-  time = max_p + fTimeShiftLoGain + (Float_t)fLoGainFirst /* this shifts the time to the start of the rising edge */
-      - ((Float_t)t_iter)/fBinningResolutionLoGain;
-
-  const Float_t timefineadjust = time_sum/sum;
-  
-  if (TMath::Abs(timefineadjust) < 4./fBinningResolutionLoGain)
-    time -= timefineadjust;
-
-}
-
+    const Int_t range = fLoGainLast - fLoGainFirst + 1;
+
+    const Byte_t *end = ptr + range;
+    Byte_t *p     = ptr;
+
+    //
+    // Prepare the low-gain pedestal
+    //
+    const Float_t pedes  = ped.GetPedestal();
+    const Float_t ABoffs = ped.GetPedestalABoffset();
+
+    const Float_t pedmean[2] = { pedes + ABoffs, pedes - ABoffs };
+
+    //
+    // Check for saturation in all other slices
+    //
+    Float_t *sample = fLoGainSignal.GetArray();
+    Int_t    ids    = fLoGainFirst;
+
+    while (p<end)
+    {
+        *sample++ = (Float_t)*p - pedmean[(ids++ + abflag) & 0x1];
+
+        if (*p++ >= fSaturationLimit)
+            sat++;
+    }
+
+    FindTimeAndChargeLoGain2(fLoGainSignal.GetArray(), range,
+                             sum, dsum, time, dtime,
+                             sat, 0);
+
+}
+*/
 // --------------------------------------------------------------------------
 //
@@ -681,6 +478,4 @@
 {
 
-  Byte_t hw = fWindowSizeHiGain;
-  Byte_t lw = fWindowSizeLoGain;
   Bool_t rc = kFALSE;
 
@@ -690,4 +485,7 @@
       rc = kTRUE;
   }
+   /*
+  Byte_t hw = fWindowSizeHiGain;
+  Byte_t lw = fWindowSizeLoGain;
 
   if (IsEnvDefined(env, prefix, "WindowSizeHiGain", print))
@@ -704,5 +502,5 @@
   if (rc)
     SetWindowSize(hw, lw);
-  
+
   Bool_t rc2 = kFALSE;
   Int_t brh = fBinningResolutionHiGain;
@@ -725,5 +523,5 @@
       rc = kTRUE;
     }
-  
+   */
   if (IsEnvDefined(env, prefix, "WeightsFile", print))
     {
@@ -823,5 +621,5 @@
             }
 
-            if (2!=sscanf(str.Data(), "# High Gain Weights:%2i %2i", &fWindowSizeHiGain, &fBinningResolutionHiGain))
+            if (2!=sscanf(str.Data(), "# High Gain Weights: %2i %2i", &fWindowSizeHiGain, &fBinningResolutionHiGain))
             {
                 *fLog << err << "ERROR - Wrong number of arguments in line #" << line << ":" << endl;
@@ -833,4 +631,5 @@
             fAmpWeightsHiGain .Set(len);
             fTimeWeightsHiGain.Set(len);
+            fPulseHiGain.Set(len);
             hi = kTRUE;
             continue;
@@ -845,5 +644,5 @@
             }
 
-            if (2!=sscanf(str.Data(),"# Low Gain Weights:%2i %2i", &fWindowSizeLoGain, &fBinningResolutionLoGain))
+            if (2!=sscanf(str.Data(),"# Low Gain Weights: %2i %2i", &fWindowSizeLoGain, &fBinningResolutionLoGain))
             {
                 *fLog << err << "ERROR - Wrong number of arguments in line #" << line << ":" << endl;
@@ -855,4 +654,5 @@
             fAmpWeightsLoGain .Set(len);
             fTimeWeightsLoGain.Set(len);
+            fPulseLoGain.Set(len);
             lo = kTRUE;
             continue;
@@ -867,7 +667,8 @@
             continue;
 
-        if (2!=sscanf(str.Data(), "%f %f",
+        if (3!=sscanf(str.Data(), "%f %f %f",
                       lo ? &fAmpWeightsLoGain [cnt] : &fAmpWeightsHiGain [cnt],
-                      lo ? &fTimeWeightsLoGain[cnt] : &fTimeWeightsHiGain[cnt]))
+                      lo ? &fTimeWeightsLoGain[cnt] : &fTimeWeightsHiGain[cnt],
+                      lo ? &fPulseLoGain[cnt] : &fPulseHiGain[cnt]))
         {
             *fLog << err << "ERROR - Wrong number of arguments in line #" << line << ":" << endl;
@@ -903,5 +704,5 @@
     *fLog << "with a resolution of " << fBinningResolutionLoGain << endl;
 
-    CalcBinningResArrays();
+    //CalcBinningResArrays();
 
     switch (fWindowSizeHiGain)
@@ -1058,5 +859,5 @@
     return ReadWeightsFile(name, path);
 }
-
+/*
 //----------------------------------------------------------------------------
 //
@@ -1125,5 +926,5 @@
   Int_t start = fBinningResolutionHiGain*(fSignalStartBinHiGain + 1);
 
-  for (Int_t i = -fBinningResolutionHalfHiGain+1; i<=fBinningResolutionHalfHiGain; i++)
+  for (Int_t i = -fBinningResolutionHiGain/2+1; i<=fBinningResolutionHiGain/2; i++)
     {
   
@@ -1178,5 +979,5 @@
       for (Int_t count=0; count < fWindowSizeHiGain; count++)
         {
-          const Int_t idx = i+fBinningResolutionHalfHiGain+fBinningResolutionHiGain*count-1;
+          const Int_t idx = i+fBinningResolutionHiGain/2+fBinningResolutionHiGain*count-1;
           fAmpWeightsHiGain [idx] = w_amp [0][count];
           fTimeWeightsHiGain[idx] = w_time[0][count];
@@ -1246,7 +1047,7 @@
       // Loop over relative time in one BinningResolution interval
       //
-      Int_t start = fBinningResolutionLoGain*fSignalStartBinLoGain + fBinningResolutionHalfLoGain;
-      
-      for (Int_t i = -fBinningResolutionHalfLoGain+1; i<=fBinningResolutionHalfLoGain; i++)
+      Int_t start = fBinningResolutionLoGain*fSignalStartBinLoGain + fBinningResolutionLoGain/2;
+      
+      for (Int_t i = -fBinningResolutionLoGain/2+1; i<=fBinningResolutionLoGain/2; i++)
         {
           
@@ -1301,5 +1102,5 @@
           for (Int_t count=0; count < fWindowSizeLoGain; count++)
             {
-              const Int_t idx = i+fBinningResolutionHalfLoGain+fBinningResolutionLoGain*count-1;
+              const Int_t idx = i+fBinningResolutionLoGain/2+fBinningResolutionLoGain*count-1;
               fAmpWeightsLoGain [idx] = w_amp [0][count];
               fTimeWeightsLoGain[idx] = w_time[0][count];
@@ -1329,5 +1130,5 @@
   return kTRUE;
 }
-
+*/
 void MExtractTimeAndChargeDigitalFilter::Print(Option_t *o) const
 {
@@ -1336,5 +1137,4 @@
 
     MExtractTimeAndCharge::Print(o);
-    *fLog << " Time Shift  HiGain: " << fTimeShiftHiGain         << "  LoGain: " << fTimeShiftLoGain << endl;
     *fLog << " Window Size HiGain: " << fWindowSizeHiGain        << "  LoGain: " << fWindowSizeLoGain << endl;
     *fLog << " Binning Res HiGain: " << fBinningResolutionHiGain << "  LoGain: " << fBinningResolutionHiGain << endl;
